<style>
    #postTitleInput {
        font-size: 20px;
        color: #1d9fdc;
        outline: 0;
        outline: none;
        border: 1px solid #ddd;
        width: 80%;
        width: calc(100% - 55px);
        margin-right: 50px;
        font-weight: normal;
        font-family: WeblySleek, 'Myriad Set Pro', 'Lucida Grande', 'Helvetica Neue', Helvetica, Arial, Verdana, sans-serif;
        margin-bottom: 9px;
        padding-left: 5px;
    }
</style>

<script>
    window.g_thisPost = null;

    <? if($this->userCanPost) { ?>
    function openInlinePostEditor() {
        $('.hideOnEdit').hide();
        $('.showOnEdit').show();
        $('#inlinePostEditor').text(g_thisPost.content);
        initEditorOnId('#inlinePostEditor',
            '<button class="lab-button" style="float: right; margin-right: 24px; margin-top: 2px; display: inline-block;" onclick="window.parent.submitPost(window.parent.g_thisPost.id)">Save</button>');
        imageList = window.g_thisPost.images;
        imageListUpdated();
    }

    function deletePostLinkClicked($el) {
        labConfirm('Are you sure that you want to delete this post?\nThis cannot be undone!', 'Are you sure?', function(response) {
            if(response) {
                openAjaxLink($el, function () {
                    window.location.href = '<?= $this->url("root/brandFeed", ['brandUrl' => $this->brandUrl]) ?>';
                });
            }
        }, "Delete");
    }

    $(function() {
        if(window.location.hash == "#edit") {
            openInlinePostEditor();
        }
    });
    <? } ?>
</script>

<?
use LabBase\Model\Brand;
use LabBase\Model\BrandPost;
use LabBase\Model\User;

/** @var Brand $thisBrand */
/** @var bool $userCanPost */

if (!$this->thisPost) {
    // ==================
    // No post to display
?>

    <div class="feedNode">
        <div class="feedInfoBar">
            <!-- <img src="<?= $this->basePath(); ?>/img/placeholders/smallogo.png"/> -->

            <div>
                <a href="#"><h1>Page not found</h1></a>

                <p></p>
            </div>
        </div>
        <div class="feedContent">
            Sorry, the requested page has not been found.
        </div>
    </div>


<?
    }else{ // if(!$this->thisPost)
    // =========================
    // We have a post to display


    /** @var $post BrandPost */
    $post = $this->thisPost;
    $images = $post->getImageLinkArray();
?>
    <script>
        window.g_thisPost = {
            id: <?= $post->id ?>,
            content: '<?= str_replace("'", "\\'", str_replace("\n", "\\n", str_replace("\\", "\\\\", $post->postContent))) ?>',
            images: [ <?= $images ? ("'".implode("', '", $images)."'") : '' ?> ],
        };
    </script>

    <div class="feedNode">
        <? if($this->userCanEditBrand) { ?>
            <div id="post<?= $post->id ?>menu" class="postMenuIcon dropdownActivator oi" data-glyph="pencil"></div>
            <div id="post<?= $post->id ?>dropdown" class="postMenuDropdown">
                <div>
                    <a class="oi" data-glyph="pencil" href="#edit" onclick="openInlinePostEditor()">Edit post</a>
                    <a class="oi" data-glyph="x" href="<?= $this->url('root/brandFeedDeletePost', ['postId' => $post->id]) ?>" onclick="deletePostLinkClicked($(this)); return false;">Delete post</a>
                </div>
            </div>
            <script>
                makeDropdownMenu($('#post<?= $post->id ?>menu'), $('#post<?= $post->id ?>dropdown'));
            </script>
        <? } ?>


        <div class="feedInfoBar">
            <!--<img src="<?= $this->basePath(); ?>/img/placeholders/smallogo.png"/>-->

            <div>
                <a class="hideOnEdit" href="#"><h1> <?= $post->postTitle; ?> </h1></a>
                <input class="showOnEdit" id="postTitleInput" onkeypress="titleChanged($(this))" style="display: none;" type="text" value="<?= $post->postTitle; ?>" />
                <p>
                    Posted by <a href="#"><?= $thisBrand->name ?></a>
                    in <a
                        href="<?= $this->url("root/brandFeed", ['brandUrl' => $this->brandUrl, 'categoryUrl' => $post->categoryUrl]) ?>"><?= $post->categoryName ?></a>
                    -
                    <span id="post<?= $post->id; ?>date">on <?= date("d-m-Y H:i", $post->dateCreated) ?></span>
                    <script>$("#post<?= $post->id; ?>date").html(formatAgoTime(<?= $post->dateCreated ?>));</script>
                </p>
            </div>
        </div>
        <div class="feedContent hideOnEdit userContent" id="postContent">
            <?= $post->postContent; ?>
        </div>
        <? if($this->userCanEditBrand) { ?>
        <div id="inlinePostEditorContainer" class="showOnEdit" style="display: none;">
            <iframe id="editorImageSubmitterIframe" name="editorImageSubmitterIframe" style="display: none;" onload="editorImageFormSubmitted($(this))"> </iframe>
            <form onsubmit="window.postImageUploadStarted()" enctype="multipart/form-data" method="post" target="editorImageSubmitterIframe" action="<?= $this->url('root/brandFeedAddPostImage', ['brandUrl' => $brandUrl]); ?>">
                <input type="file" name="imageFile" style="display: none" id="editorImageSubmitter" onchange="$(this).parent().submit()" />
            </form>

            <div class="feedNode newPost" id="postEditorOuterContainer">
                <div id="inlinePostEditorContainer">
                    <textarea id="inlinePostEditor"></textarea>
                </div>
            </div>

            <div id="simpleImagePreviewContainer" class="feedNode stickToTop" style="display: none"></div>
        </div>
        <? }

        if($images) {
            ?>
            <div class="imageHolder hideOnEdit" style="margin-bottom: 25px;">
                <?

                if(count($images) % 2 == 1) {
                    $image = array_shift($images);
                    ?>
                    <div class="tile one"><img onclick="openFullscreenImage($(this))" src="<?= $image ?>" /></div>
                    <?
                }
                $i = 0;
                foreach($images as $image) {
                    ?>
                    <div class="tile two"><img onclick="openFullscreenImage($(this))" src="<?= $image ?>" /></div>
                    <?
                    $i++;
                }
                ?>
            </div>
            <?
        }
        ?>
        <? if ($post->commentsEnabled) { ?>
            <div class="feedContent">
                <div class="commentsHeader">
                    Comments
                    <span class="float-right">
                        <a href="#" onclick="updateComments(true); $(this).blur(); return false;">All comments</a>
                    </span>
                </div>

                <div>
                    <form id="commentForm" action="#" method="get" onsubmit="submitNewComment(); return false">
                            <textarea id="commentTextarea" class="round-border userInputTextarea"
                                      placeholder="Post a comment..."></textarea>

                        <div id="commentControls" class="clear">
                            <span class="lab-button-dropdown float-right" style="text-align: right;">
                                <input type="submit" class="lab-button connect-right" onclick="$('#commentPostAs').val('brand');" value="Post as <?= $thisBrand->name; ?>" />
                                <button id="commentPostDropdownButton" onclick="return false;" class="dropdownActivator lab-button connect-left" style="padding-left: 8px !important; padding-right: 8px !important;"><span class="oi" data-glyph="chevron-bottom"></span></button>
                                <br />
                                <span id="commentPostDropdown" class="raw inline-block-menu dropdownMenu">
                                    <div style="min-width: 120px; padding: 1px 10px; margin-top: 2px; border: 1px solid #ddd; background: #fff; float:right; display: inline-block;">
                                        <a href="#" onclick="$(this).blur(); $('#commentPostAs').val('user'); $('#commentForm').submit(); return false;">
                                            Post as <?= $this->SessionInfo()->getLoggedInUser()->fullName; ?>
                                        </a>
                                    </div>
                                </span>
                            </span>
                            <script> makeDropdownMenu($('#commentPostDropdownButton'), $('#commentPostDropdown'), 0, true); </script>
                            <?
                            if ($userCanPost) {
                                /** @var User $loggedInUser */
                                $loggedInUser = $this->SessionInfo()->getLoggedInUser();
                                ?>
                                <input type="hidden" id="commentPostAs" name="commentPostAs" value="brand" />
                                <!--
                                <select id="commentPostAs" name="postAs" title="Post as:" class="float-right">
                                    <option value="user" selected="selected">Post as yourself - <?= $loggedInUser->fullName; ?></option>
                                    <option value="brand">Post as your brand - <?= $thisBrand->name; ?></option>
                                </select>
                                -->
                                <?
                            }
                            ?>
                        </div>
                    </form>
                </div>

                <script>
                    var commentMenuAntiDoubleclick = 0;
                    var commentMenuAntiDoubleclickObject = 0;
                    function commentMenuClick(el) {
                        if (commentMenuAntiDoubleclickObject == el && commentMenuAntiDoubleclick > new Date().getTime()) {
                            return false;
                        }
                        commentMenuAntiDoubleclickObject = el;
                        commentMenuAntiDoubleclick = new Date().getTime() + 800;

                        var $this = $(el);
                        var url = $this.attr('href');
                        ajaxSubmit(url, {}, function (data) {
                            if (!data.status || data.status != "ok") {
                                console.log("commentMenuClick error: ", data);
                                labAlert(data.status ? data.status : "An error has occurred, please try again.");
                            } else {
                                updateComments(); // todo refresh given comment
                            }
                        });

                        return false;
                    }

                    var $commentTextarea = $('#commentTextarea');
                    var $commentControls = $('#commentControls');
                    var commentClicked = false;
                    var systemMessageInComment = false;
                    function showSystemMessageInCommentBox(text) {
                        $commentControls.animate({height: '0'}, 400, function () {
                            $commentControls.hide();
                            commentClicked = false;
                        });
                        $commentTextarea.css({backgroundColor: '#e9f7e8', color: '#555'});
                        $commentTextarea.val(text);
                        systemMessageInComment = true;
                    }
                    $commentTextarea.click(function () {
                        if (!commentClicked) {
                            commentClicked = true;

                            if (systemMessageInComment) {
                                $commentTextarea.css({backgroundColor: 'white', color: '#111'});
                                $commentTextarea.val('');
                            }

                            // If the user did not change the textarea size (its height is close 40 => assume not resized)
                            if (Math.abs(40 - $commentTextarea.outerHeight()) < 5) {
                                $commentTextarea.animate({height: '65px'}, 400);
                            }
                            $commentControls.show();
                            $commentControls.animate({height: '60px'}, 400);
                        }
                    });

                    $(function () {
                        window.setTimeout(function () {
                            updateComments();
                        }, 100);
                    });
                    var loadedComments = [];
                    var lastCommentUpdate = new Date().getTime();
                    function updateComments(lowPriority) {
                        if (lowPriority) {
                            if (lastCommentUpdate + 1000 * 3 > new Date().getTime())
                                return;
                        }
                        lastCommentUpdate = new Date().getTime();

                        var params = {};

                        if (loadedComments.length > 0) {
                            var firstId = loadedComments[0].id;
                            var lastId = loadedComments[loadedComments.length - 1].id;
                            if (lastId > firstId) {
                                var tmp = lastId;
                                lastId = firstId;
                                firstId = tmp;
                            }
                            params = {
                                firstId: firstId,
                                lastId: lastId
                            }
                        }

                        $.post("<?= $this->url("root/brandPostComments", ["postId" => $post->id]) ?>", params, function (data) {
                            if (data.status != "ok") {
                                console.log("updateComments error: " + data.status);
                            } else {
                                console.log(data);
                                loadedComments = data.comments;

                                loadedComments.sort(function (a, b) {
                                    return b.id - a.id;
                                });

                                displayComments(loadedComments);
                            }
                        });
                    }


                    function displayComments(comments) {
                        var $commentsContainer = $("#commentsContainer");
                        console.log($commentsContainer);
                        $commentsContainer.empty();

                        var commentCount = 0;
                        for (var k in comments) {
                            commentCount++;
                            var c = comments[k];

                            // don't display any rejected comments in this view
                            // (rejected comments are sent only to brand managers)
                            if (c.rejected)
                                continue;

                            var name = c.name;
                            if (c.nameUrl && c.nameUrl.length > 0) {
                                name = '<a href="' + c.nameUrl + '">' + name + '</a>';
                            }
                            var content = '<p>' + c.text.replace('\n\n', '\n').replace('\n', '</p><p>') + '</p>';
                            var menu = '';
                            var time = formatAgoTime(c.datePosted);
                            var classes = 'comment';
                            if (!c.public) classes += ' notPublic';

                            <? if($userCanPost) { ?>

                            var manageURL = "<?= $this->url('root/brandPostManageComment', ['commentId' => 'COMMENTID', 'action' => 'ACTION']) ?>";
                            var fURL = function (id, action) {
                                return manageURL.replace('COMMENTID', id).replace('ACTION', action);
                            };

                            if (!c.public) {
                                menu += '<a onclick="return commentMenuClick(this);" href="' + fURL(c.id, 'approveComment') + '">Approve</a> - ';
                                menu += '<a onclick="return commentMenuClick(this);" href="' + fURL(c.id, 'rejectComment') + '">Reject</a> ';
                            } else {
                                menu += '<a onclick="return commentMenuClick(this);" href="' + fURL(c.id, 'rejectComment') + '">Remove comment</a> ';
                            }

                            <? } ?>

                            var template =
                                '<div class="' + classes + '"><div class="inline-block"><header>' +
                                name + '<small> - ' + time + '</small></header></div>' +
                                '<div class="menu">' + menu + '</div><div>' + content + '</div></div>';

                            $commentsContainer.append($.parseHTML(template));

                        }
                        if(commentCount == 0) {
                            $commentsContainer.text("There are no comments yet - be first to leave one!")
                        }
                    }

                    <?
                        $loggedInUser = $this->SessionInfo()->getLoggedInUser();
                        if($loggedInUser) {
                    ?> /* A user is logged in, send the form */
                    function submitNewComment() {
                        var url = "<?= $this->url("root/brandPostPostComment", ['postId' => $post->id]) ?>";
                        var postAs = $('#commentPostAs').val();
                        if (!postAs) postAs = 'user';
                        var postContent = $commentTextarea.val();

                        $commentControls.animate({height: '0'}, 400, function () {
                            $commentControls.hide();
                            commentClicked = false;
                        });

                        ajaxSubmit(url, {
                            text: postContent,
                            postAs: postAs

                        }, function (data) {
                            if (!data.status || data.status != 'ok') {
                                if (data.status)
                                    labAlert(data.status);
                                else
                                    labAlert('Sorry, an error has occured while posting your comment.')
                            } else {
                                showSystemMessageInCommentBox('Thank you!\n\nYour comment has been submitted and will be reviewed by an administrator.');
                            }

                            updateComments();
                        });
                    }
                    <?
                        }else{
                    ?>
                    function submitNewComment() {
                        var d = new Dialog({}, [
                            new DialogComponent(null, 'label', 'Please <a href="<?= $this->url('root/signin') ?>">log in</a> or provide your details below to continue'),
                            new DialogComponent('name', 'text', 'Name', 'John'),
                            new DialogComponent('email', 'text', 'Email', 'someone@domain.com'),
                            new DialogComponent(null, 'row', [
                                new DialogComponent(null, 'button', 'Submit', true),
                                new DialogComponent(null, 'button', 'Cancel', false),
                            ], 'right')
                        ], function(dialog, component, userData) {
                            if(userData) {
                                var name = dialog.getComponentById('name').getElement().value.trim();
                                var email = dialog.getComponentById('email').getElement().value.trim();
                                if(name.length < 1 || !/.+@.+\..+/.test(email)) {
                                    labAlert("Please provide your name and email address", "Error");
                                    return;
                                }

                                var url = "<?= $this->url("root/brandPostPostComment", ['postId' => $post->id]) ?>";
                                var postContent = $commentTextarea.val();

                                $commentControls.animate({height: '0'}, 400, function () {
                                    $commentControls.hide();
                                    commentClicked = false;
                                });

                                dialog.close();
                                showSystemMessageInCommentBox("Submitting your comment...");

                                ajaxSubmit(url, {
                                    text: postContent,
                                    name: name,
                                    email: email

                                }, function (data) {
                                    if (!data.status || data.status != 'ok') {
                                        if (data.status)
                                            labAlert(data.status);
                                        else
                                            labAlert('Sorry, an error has occured while posting your comment.')
                                    } else {
                                        showSystemMessageInCommentBox('Thank you!\n\nYour comment has been submitted and will be reviewed by an administrator.');
                                    }

                                    updateComments();
                                });

                            }else{
                                dialog.close();
                            }
                        });

                        d.show();
                        



                    }

                    <?  } ?>
                </script>

                <div id="commentsContainer">
                    Loading comments...
                </div>
            </div>
        <? } // end if comments enabled ?>
    </div>
    <?
}